; ===============================================================
; Required Headers
; ===============================================================

.include "Includes/headers.inc"

; ===============================================================
; Main entry point
; ===============================================================

; Note; 0,(iy+asm_Flag1) means interlace on/off

.varloc saveSScreen, 768

.var 1, _rot_a		; Rotation angle
.var 1, _rot_da		; Change in rotation angle
.var 1, _move_d		; Change in movement (speed)
.var 2, _camera_x	; Camera X position
.var 2, _camera_y	; Camera Y position

_screen_width = 64	; in pixels!

main

	xor a
	ld (_rot_da),a
	ld (_move_d),a
	ld (_rot_a),a
	
	ld hl,0
	ld (_camera_x),hl
	ld (_camera_y),hl
	

_loop


	di

	; Calculate the various deltas:
	
	ld a,(_rot_a)
	ld l,a
	ld h,0
	add hl,hl
	ld de,_sin_table
	add hl,de
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld (_deltay+1),bc


	ld h,b
	ld l,c
	bit 0,(iy+asm_Flag1)
	jp z,{+}
	add hl,hl
+
	dec hl
	ld a,h
	cpl
	ld (_doffx+2),a
	ld a,l
	cpl
	ld (_doffx+1),a
	

	ld a,(_rot_a)
	add a,64
	ld l,a
	ld h,0
	add hl,hl
	add hl,de
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld (_deltax+1),bc

	bit 0,(iy+asm_Flag1)
	jp z,{+}
	ld h,b
	ld l,c
	add hl,hl
	ld (_doffy+1),hl
	jp {++}
+
	ld (_doffy+1),bc
++
	
	; Calculate the frame's initial offset
	
	; -(32*doffx+48*deltax),-(32*doffy+48*deltay)
	
	ld hl,(_deltax+1)
	add hl,hl \ add hl,hl \ add hl,hl \ add hl,hl\ add hl,hl
	ld d,h \ ld e,l
	ld hl,(_doffx+1)
	add hl,hl \ add hl,hl \ add hl,hl \ add hl,hl
	bit 0,(iy+asm_Flag1)
	jp nz,{+}
	add hl,hl
+
	add hl,de
	ld de,(_camera_x)
	add hl,de
	dec hl
	ld a,h \ cpl \ ld (_offset_x+2),a
	ld a,l \ cpl \ ld (_offset_x+1),a
	
	
	ld hl,(_deltay+1)
	add hl,hl \ add hl,hl \ add hl,hl \ add hl,hl\ add hl,hl
	ld d,h \ ld e,l
	ld hl,(_doffy+1)
	add hl,hl \ add hl,hl \ add hl,hl \ add hl,hl
	bit 0,(iy+asm_Flag1)
	jp nz,{+}
	add hl,hl
+
	add hl,de
	ld de,(_camera_y)
	add hl,de	
	dec hl
	ld a,h \ cpl \ ld (_offset_y+2),a
	ld a,l \ cpl \ ld (_offset_y+1),a
	

	ld hl,plotSScreen+(96-_screen_width)/16

	bit 0,(iy+asm_Flag1)
	jp z,{+}
_interlace_buffer_offset
	ld de,$0000
	add hl,de
	ld a,e
	or a
	jp z,{+}
	; We need to offset the offset_x/y by ONE ROW:
	push hl
	ld hl,(_offset_x+1) \ ld de,(_doffx+1) \ sra d \ rr e \ add hl,de \ ld (_offset_x+1),hl
	ld hl,(_offset_y+1) \ ld de,(_doffy+1) \ sra d \ rr e \ add hl,de \ ld (_offset_y+1),hl	
	jp {++}
+
	push hl ; Save current write address to stack
++

	ld a,(96-_screen_width)/8
	ld ixh,64
	bit 0,(iy+asm_Flag1)
	jp z,{+}
	ld ixh,32
	ld a,(96-_screen_width)/8+12
+	ld (_scanline_offset+1),a

_screen_loop
	
	; Calulate the scanline's initial offsets
_offset_x ld hl,$0000
_doffx	ld de,$0000
	add hl,de
	ld (_offset_x+1),hl
	ld (_pxlx+1),hl
	
_offset_y ld hl,$0000
_doffy	ld de,$0000
	add hl,de
	ld (_offset_y+1),hl
	ld (_pxly+1),hl
	
	ld bc,$0080
	ld ixl,_screen_width/8

_scanline_loop


	ld e,7

	ld a,(_pxly+2)
	
	push af
	and $F0
	ld l,a
	
	ld a,(_pxlx+2)
	srl a
	srl a
	srl a
	srl a
	add a,l
	ld l,a
	ld h,Map >> 8
	ld a,(hl)
	ld l,a
	
	pop af
		
	srl a
	and e
	add a,l
	ld l,a
	ld h,Img >> 8
	ld d,(hl)
			
	ld a,(_pxlx+2)
	srl a
	and e
	ld l,a
	ld h,ImgBitmasks >> 8
	ld a,d
	and (hl)

	jp z,{+}
	ld a,b
	or c
	ld b,a
+	
	srl c
	jp nc,{+}

	; Output the byte
	pop hl
	ld (hl),b
	inc hl
	push hl
	
	ld bc,$0080	
	dec ixl
	jp z,_finished_scanline
+

_pxlx	ld hl,$0000
_deltax	ld de,$0000
	add hl,de
	ld (_pxlx+1),hl
	
_pxly	ld hl,$0000
_deltay	ld de,$0000
	add hl,de
	ld (_pxly+1),hl
	
	jp _scanline_loop

_finished_scanline

	pop hl
_scanline_offset
	ld de,4
	add hl,de
	push hl
	
	dec ixh
	jp nz,_screen_loop
	pop hl
	
	ld a,(_interlace_buffer_offset+1)
	xor 12
	ld (_interlace_buffer_offset+1),a
	
	call ionFastCopy
	
	ei
	
	; Move camera angle
	ld a,(_rot_da)
	ld b,a
	ld a,(_rot_a)
	add a,b
	ld (_rot_a),a
	ld a,b
	or a
	jr z,{+}
	jp p,{++}
	inc a
	jp {+}
++	dec a
+	ld (_rot_da),a
	


	; Move camera along

	.for x, 0, 1
	ld a,(_move_d)
	or a
	jp z,{++}
	ld b,a
	ld a,(_rot_a)

	add a,!x ? 128 : 64
	
>	_to_adjust = !x ? _camera_x : _camera_y
	
	ld l,a
	ld h,0
	add hl,hl
	ld de,_sin_table
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	
	ld hl,(_to_adjust)

	ld a,b
	bit 7,a
	jr z,{+}
	neg
	ld b,a
	dec de
	ld a,d \ cpl \ ld d,a
	ld a,e \ cpl \ ld e,a
+

-	add hl,de
	djnz {-}
+
	ld (_to_adjust),hl
++
	.loop
	
	
	; Handle keys
	
	ld a,$FF
	out (1),a
	ld a,$FE
	out (1),a
	in a,(1)	
	ld b,a
	
	
	
	.for x, 0, 1
>	_to_adjust = !x ? _rot_da : _move_d	
	ld a,(_to_adjust)
	bit !x?2:3,b
	jr nz,{+}
	add a,2
+	bit !x?1:0,b
	jr nz,{+}
	sub 2
+	
	cp -9
	jr z,{+}
	cp -8
	jr z,{+}
	cp 9
	jr z,{+}
	cp 8
	jr z,{+}
	ld (_to_adjust),a
+	.loop

	ld a,(_move_d)
	or a
	jr z,{+}
	jp p,{++}
	inc a
	jp {+}
++	dec a
+	ld (_move_d),a	


	bcall(_GetCSC)
	cp skClear
	jp nz,_loop
	ld a,(iy+asm_Flag1)
	xor 1
	ld (iy+asm_Flag1),a	
	ret

_sin_table
.dwsin 256, 256, 0, 255, 1, 0
;           ^^^ change this to change the scale: 128=4:1, 256=2:1, 512=1:1 (&c)


.align 256
ImgBitmasks
.for x,0,7
	.db 1 << (7-x)
.loop

.align 256
Map
.for x,0,15
 .for y,0,15
  .db ((x^y)&7)*8
 .loop
.loop



.align 256
Img


.db %10000001
.db %00111100
.db %01101110
.db %01011110
.db %01011110
.db %01101110
.db %00111100
.db %10000001


.db %11111111
.db %10101101
.db %11001001
.db %11100011
.db %10000101
.db %11100111
.db %11011011
.db %11111111

.db %11111111
.db %10000000
.db %10001000
.db %10011000
.db %10001000
.db %10001000
.db %10001000
.db %10000000

.db %11111111
.db %10000000
.db %10111110
.db %10000010
.db %10111110
.db %10100000
.db %10111110
.db %10000000

.db %11111111
.db %10000000
.db %10111110
.db %10000010
.db %10111110
.db %10000010
.db %10111110
.db %10000000

.db %11111111
.db %10000000
.db %10100010
.db %10100010
.db %10111110
.db %10000010
.db %10000010
.db %10000000

.fill 8, $FF

.fillw 4, %0101010110101010
